'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lezerQatam = require('lezer-qatam');
var language = require('@codemirror/language');

const qatam = language.LRLanguage.define({
  parser: lezerQatam.parser.configure({
    props: [
      language.foldNodeProp.add({
        'Block Object List Args Params': language.foldInside,
      }),
      language.indentNodeProp.add({
        'Block Object': language.delimitedIndent({ closing: '}' }),
        List: language.delimitedIndent({ closing: ']' }),
        'Args Params': language.delimitedIndent({ closing: ')' }),
      }),
    ],
    languageData: {
      closeBrackets: { brackets: ['(', '[', '{', '"'] },
      commentTokens: { line: '#' },
    },
  }),
});

exports.qatam = qatam;
