import { parser } from 'lezer-qatam';
import { LRLanguage, foldNodeProp, foldInside, indentNodeProp, delimitedIndent } from '@codemirror/language';

const qatam = LRLanguage.define({
  parser: parser.configure({
    props: [
      foldNodeProp.add({
        'Block Object List Args Params': foldInside,
      }),
      indentNodeProp.add({
        'Block Object': delimitedIndent({ closing: '}' }),
        List: delimitedIndent({ closing: ']' }),
        'Args Params': delimitedIndent({ closing: ')' }),
      }),
    ],
    languageData: {
      closeBrackets: { brackets: ['(', '[', '{', '"'] },
      commentTokens: { line: '#' },
    },
  }),
});

export { qatam };
